
function DrawMainWindow()

	local tempWidth = 200;
	local tempHeight = 330;

	-- Main Parent window to hold all the elements
	wMainWinParent = Turbine.UI.Lotro.Window();
	wMainWinParent:SetSize(tempWidth,tempHeight);
	wMainWinParent:SetPosition(SETTINGS.MAINWIN.X,SETTINGS.MAINWIN.Y);
	wMainWinParent:SetText(PLUGINNAME);
	wMainWinParent:SetVisible(SETTINGS.MAINWIN.VISIBLE);

	Onscreen(wMainWinParent); -- Makes sure the window is still onscreen (perhaps user changed resolution since last playing)

	-- Background control to hold the background image
	wMainBack = Turbine.UI.Control();
	wMainBack:SetParent(wMainWinParent);
	wMainBack:SetSize(197,329);
	wMainBack:SetPosition(2,-5);
	wMainBack:SetBlendMode(4);
	wMainBack:SetBackground(_IMAGES.MAINBACK);
	wMainBack:SetMouseVisible(false);

	btnUpdates = Turbine.UI.Lotro.Button();
	btnUpdates:SetParent(wMainWinParent);
	btnUpdates:SetWidth(70);
	btnUpdates:SetPosition((tempWidth/2)-(btnUpdates:GetWidth()+5),tempHeight-40);
	btnUpdates:SetText(_LANG.PAUSE[SETTINGS.LANGUAGE]);

	btnUpdates.Click = function (sender, args)
		if btnUpdates:GetText() == _LANG.PAUSE[SETTINGS.LANGUAGE] then
			wMainWinParent:SetWantsUpdates(false);
			btnUpdates:SetText(_LANG.START[SETTINGS.LANGUAGE]);
		else
			wMainWinParent:SetWantsUpdates(true);
			btnUpdates:SetText(_LANG.PAUSE[SETTINGS.LANGUAGE]);
		end
	end

	btnStats = Turbine.UI.Lotro.Button();
	btnStats:SetParent(wMainWinParent);
	btnStats:SetWidth(70);
	btnStats:SetPosition((tempWidth/2)+5,tempHeight-40);
	btnStats:SetText(_LANG.STATS[SETTINGS.LANGUAGE]);

	btnStats.Click = function (sender, args)
		SETTINGS.STATWIN.VISIBLE = true;
		wStatWinParent:SetVisible(true);
	end


	-- Labels ---------------------------------------------------------
	lbltitleDuration = Turbine.UI.Label();
	lbltitleDuration:SetParent(wMainWinParent);
	lbltitleDuration:SetSize(160,20);
	lbltitleDuration:SetPosition(10,50);
	lbltitleDuration:SetFont(BFONT);
	lbltitleDuration:SetForeColor(YELLOW);
	lbltitleDuration:SetText(_LANG.DURATION[SETTINGS.LANGUAGE]);

	lblRoundDuration = Turbine.UI.Label();
	lblRoundDuration:SetParent(wMainWinParent);
	lblRoundDuration:SetSize(160,40);
	lblRoundDuration:SetPosition(20,70);
	lblRoundDuration:SetFont(TIMEFONT);


	lbltitleQstTH = Turbine.UI.Label();
	lbltitleQstTH:SetParent(wMainWinParent);
	lbltitleQstTH:SetSize(160,20);
	lbltitleQstTH:SetPosition(10,100);
	lbltitleQstTH:SetFont(BFONT);
	lbltitleQstTH:SetForeColor(YELLOW);
	lbltitleQstTH:SetText(_LANG.THRESET[SETTINGS.LANGUAGE]);

	lblCDTH = Turbine.UI.Label();
	lblCDTH:SetParent(wMainWinParent);
	lblCDTH:SetSize(160,40);
	lblCDTH:SetPosition(20,120);
	lblCDTH:SetFont(TIMEFONT);

	local CURTIME = Turbine.Engine.GetLocalTime();
	if CURTIME > STATS[MYNAME].QUESTTHEXP then
		-- Quest has cooled-down
		lblCDTH:SetText(_LANG.QUESTRESET[SETTINGS.LANGUAGE]);
	else
		QUESTTH = STATS[MYNAME].QUESTTHEXP;
		QUESTTHCOMPLETE = true;
	end

	lbltitleQstBER = Turbine.UI.Label();
	lbltitleQstBER:SetParent(wMainWinParent);
	lbltitleQstBER:SetSize(160,20);
	lbltitleQstBER:SetPosition(10,150);
	lbltitleQstBER:SetFont(BFONT);
	lbltitleQstBER:SetForeColor(YELLOW);
	lbltitleQstBER:SetText(_LANG.BERRESET[SETTINGS.LANGUAGE]);

	lblCDBERRY = Turbine.UI.Label();
	lblCDBERRY:SetParent(wMainWinParent);
	lblCDBERRY:SetSize(160,40);
	lblCDBERRY:SetPosition(20,170);
	lblCDBERRY:SetFont(TIMEFONT);

	if CURTIME > STATS[MYNAME].QUESTBEREXP then
		-- Quest has cooled-down
		lblCDBERRY:SetText(_LANG.QUESTRESET[SETTINGS.LANGUAGE]);
	else
		QUESTBER = STATS[MYNAME].QUESTBEREXP;
		QUESTBERCOMPLETE = true;
	end

	-- Quickslots ---------------------------------------------------------------------
	qsCaveClaws = Turbine.UI.Lotro.ItemControl();
	qsCaveClaws:SetParent(wMainWinParent);
	qsCaveClaws:SetPosition(20,200);

	caveclaw_overlay = Turbine.UI.Control();
	caveclaw_overlay:SetParent(qsCaveClaws);
	caveclaw_overlay:SetSize(32,32);
	caveclaw_overlay:SetPosition(3,3);
	caveclaw_overlay:SetBackground(_IMAGES.GREY_CAVECLAW);
	caveclaw_overlay:SetMouseVisible(false);

	caveClaw_itemcontrol = Turbine.UI.Lotro.ItemInfoControl();
	caveClaw_itemcontrol:SetParent(qsCaveClaws);
	caveClaw_itemcontrol:SetSize(32,32);
	caveClaw_itemcontrol:SetPosition(0,0);
	caveClaw_itemcontrol:SetMouseVisible(false);


	qsDowsing = Turbine.UI.Lotro.ItemControl();
	qsDowsing:SetParent(wMainWinParent);
	qsDowsing:SetPosition(60,200);

	dowsing_overlay = Turbine.UI.Control();
	dowsing_overlay:SetParent(qsDowsing);
	dowsing_overlay:SetSize(32,32);
	dowsing_overlay:SetPosition(3,3);
	dowsing_overlay:SetBackground(_IMAGES.GREY_DOWSING);
	dowsing_overlay:SetMouseVisible(false);

	dowsing_itemcontrol = Turbine.UI.Lotro.ItemInfoControl();
	dowsing_itemcontrol:SetParent(qsDowsing);
	dowsing_itemcontrol:SetSize(32,32);
	dowsing_itemcontrol:SetPosition(0,0);
	dowsing_itemcontrol:SetMouseVisible(false);


	qsPicks = Turbine.UI.Lotro.ItemControl();
	qsPicks:SetParent(wMainWinParent);
	qsPicks:SetPosition(100,200);

	picks_overlay = Turbine.UI.Control();
	picks_overlay:SetParent(qsPicks);
	picks_overlay:SetSize(32,32);
	picks_overlay:SetPosition(3,3);
	picks_overlay:SetBackground(_IMAGES.GREY_PICK);
	picks_overlay:SetMouseVisible(false);

	picks_itemcontrol = Turbine.UI.Lotro.ItemInfoControl();
	picks_itemcontrol:SetParent(qsPicks);
	picks_itemcontrol:SetSize(32,32);
	picks_itemcontrol:SetPosition(0,0);
	picks_itemcontrol:SetMouseVisible(false);


	tokens_image = Turbine.UI.Control();
	tokens_image:SetParent(wMainWinParent);
	tokens_image:SetSize(32,32);
	tokens_image:SetPosition(140,202);
	tokens_image:SetBlendMode(4);
	tokens_image:SetBackground(_IMAGES.GREY_TOKENS);
	tokens_image:SetMouseVisible(false);

	tokens_image.Update = function (sender,args)
		tokens_image:SetWantsUpdates(false);
		GetTokenIndex();
	end

	tokens_label_overlay = Turbine.UI.Label();
	tokens_label_overlay:SetParent(wMainWinParent);
	tokens_label_overlay:SetSize(30,14);
	tokens_label_overlay:SetPosition(tokens_image:GetLeft()+1,tokens_image:GetTop()+15);
	tokens_label_overlay:SetFont(Turbine.UI.Lotro.Font.Verdana12);
	tokens_label_overlay:SetForeColor(YELLOW);
	tokens_label_overlay:SetFontStyle(Turbine.UI.FontStyle.Outline);
	tokens_label_overlay:SetOutlineColor(BLACK);
	tokens_label_overlay:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	tokens_label_overlay:SetText("0");


	qsSmallCache = Turbine.UI.Lotro.ItemControl();
	qsSmallCache:SetParent(wMainWinParent);
	qsSmallCache:SetPosition(20,242);

	treasuresmall_overlay = Turbine.UI.Control();
	treasuresmall_overlay:SetParent(qsSmallCache);
	treasuresmall_overlay:SetSize(32,32);
	treasuresmall_overlay:SetPosition(3,3);
	treasuresmall_overlay:SetBackground(_IMAGES.GREY_TREASURESMALL);
	treasuresmall_overlay:SetMouseVisible(false);

	treasureSmall_itemcontrol = Turbine.UI.Lotro.ItemInfoControl();
	treasureSmall_itemcontrol:SetParent(qsSmallCache);
	treasureSmall_itemcontrol:SetSize(32,32);
	treasureSmall_itemcontrol:SetPosition(0,0);
	treasureSmall_itemcontrol:SetMouseVisible(false);


	qsMedCache = Turbine.UI.Lotro.ItemControl();
	qsMedCache:SetParent(wMainWinParent);
	qsMedCache:SetPosition(60,242);

	treasuresmed_overlay = Turbine.UI.Control();
	treasuresmed_overlay:SetParent(qsMedCache);
	treasuresmed_overlay:SetSize(32,32);
	treasuresmed_overlay:SetPosition(3,3);
	treasuresmed_overlay:SetBackground(_IMAGES.GREY_TREASUREMED);
	treasuresmed_overlay:SetMouseVisible(false);

	treasureMed_itemcontrol = Turbine.UI.Lotro.ItemInfoControl();
	treasureMed_itemcontrol:SetParent(qsMedCache);
	treasureMed_itemcontrol:SetSize(32,32);
	treasureMed_itemcontrol:SetPosition(0,0);
	treasureMed_itemcontrol:SetMouseVisible(false);


	qsLargeCache = Turbine.UI.Lotro.ItemControl();
	qsLargeCache:SetParent(wMainWinParent);
	qsLargeCache:SetPosition(100,242);

	treasureslarge_overlay = Turbine.UI.Control();
	treasureslarge_overlay:SetParent(qsLargeCache);
	treasureslarge_overlay:SetSize(32,32);
	treasureslarge_overlay:SetPosition(3,3);
	treasureslarge_overlay:SetBackground(_IMAGES.GREY_TREASURELARGE);
	treasureslarge_overlay:SetMouseVisible(false);

	treasureLarge_itemcontrol = Turbine.UI.Lotro.ItemInfoControl();
	treasureLarge_itemcontrol:SetParent(qsLargeCache);
	treasureLarge_itemcontrol:SetSize(32,32);
	treasureLarge_itemcontrol:SetPosition(0,0);
	treasureLarge_itemcontrol:SetMouseVisible(false);


	qsHugeCache = Turbine.UI.Lotro.ItemControl();
	qsHugeCache:SetParent(wMainWinParent);
	qsHugeCache:SetPosition(140,242);

	treasureshuge_overlay = Turbine.UI.Control();
	treasureshuge_overlay:SetParent(qsHugeCache);
	treasureshuge_overlay:SetSize(32,32);
	treasureshuge_overlay:SetPosition(3,3);
	treasureshuge_overlay:SetBackground(_IMAGES.GREY_TREASUREHUGE);
	treasureshuge_overlay:SetMouseVisible(false);

	treasureshuge_itemcontrol = Turbine.UI.Lotro.ItemInfoControl();
	treasureshuge_itemcontrol:SetParent(qsHugeCache);
	treasureshuge_itemcontrol:SetSize(32,32);
	treasureshuge_itemcontrol:SetPosition(0,0);
	treasureshuge_itemcontrol:SetMouseVisible(false);



	LocateItems();
	GetTokenIndex();

	MYBAGS.ItemAdded = function (sender,args)
		LocateItems();
	end

	MYBAGS.ItemMoved = function (sender,args)
		LocateItems();
	end

	MYBAGS.ItemRemoved = function (sender,args)
		wMainBack:SetWantsUpdates(true);
	end

	wMainBack.Update = function (sender, args)
		wMainBack:SetWantsUpdates(false);
		LocateItems();
	end

	MYBAGS.SizeChanged = function (sender,args)
		LocateItems();
	end

	wMainWinParent:SetWantsUpdates(true);

	wMainWinParent.Update = function (sender, args)
		UpdateLabels();
	end

	-- Window events
	wMainWinParent.Closing = function()
		SETTINGS.MAINWIN.VISIBLE = false;
	end

	wMainWinParent.PositionChanged = function()
		SETTINGS.MAINWIN.X = wMainWinParent:GetLeft();
		SETTINGS.MAINWIN.Y = wMainWinParent:GetTop();
	end

end


function LocateItems()

	local BAGSIZE = MYBAGS:GetSize();


	local CAVECLAWCOUNT = 0;
	local DOWSINGCOUNT = 0;
	local PICKCOUNT = 0;
	local SMALLCACHECOUNT = 0;
	local MEDIUMCACHECOUNT = 0;
	local LARGECACHECOUNT = 0;
	local HUGECACHECOUNT = 0;


	for i=1, BAGSIZE do
		if MYBAGS:GetItem(i) ~= nil then

			local CURITEM = MYBAGS:GetItem(i);
			local CURNAME = CURITEM:GetName();

			if CURNAME == _LANG.CAVECLAW[SETTINGS.LANGUAGE] then
				CAVECLAWCOUNT = CAVECLAWCOUNT + CURITEM:GetQuantity();
				qsCaveClaws:SetItem(CURITEM);
				caveClaw_itemcontrol:SetItemInfo(CURITEM);
			end

			if CURNAME == _LANG.DOWSING[SETTINGS.LANGUAGE] then
				DOWSINGCOUNT = DOWSINGCOUNT + CURITEM:GetQuantity();
				qsDowsing:SetItem(CURITEM);
				dowsing_itemcontrol:SetItemInfo(CURITEM);
			end

			if CURNAME == _LANG.PICK[SETTINGS.LANGUAGE] then
				PICKCOUNT = PICKCOUNT + CURITEM:GetQuantity();
				qsPicks:SetItem(CURITEM);
				picks_itemcontrol:SetItemInfo(CURITEM);
			end

			if CURNAME == _LANG.SMALLCACHE[SETTINGS.LANGUAGE] then
				SMALLCACHECOUNT = SMALLCACHECOUNT + CURITEM:GetQuantity();
				qsSmallCache:SetItem(CURITEM);
				treasureSmall_itemcontrol:SetItemInfo(CURITEM);
			end

			if CURNAME == _LANG.MEDCACHE[SETTINGS.LANGUAGE] then
				MEDIUMCACHECOUNT = MEDIUMCACHECOUNT + CURITEM:GetQuantity();
				qsMedCache:SetItem(CURITEM);
				treasureMed_itemcontrol:SetItemInfo(CURITEM);
			end

			if CURNAME == _LANG.LARGECACHE[SETTINGS.LANGUAGE] then
				LARGECACHECOUNT = LARGECACHECOUNT + CURITEM:GetQuantity();
				qsLargeCache:SetItem(CURITEM);
				treasureLarge_itemcontrol:SetItemInfo(CURITEM);
			end

			if CURNAME == _LANG.HUGECACHE[SETTINGS.LANGUAGE] then
				HUGECACHECOUNT = HUGECACHECOUNT + CURITEM:GetQuantity();
				qsHugeCache:SetItem(CURITEM);
				treasureshuge_itemcontrol:SetItemInfo(CURITEM);
			end
		end
	end

	caveClaw_itemcontrol:SetQuantity(CAVECLAWCOUNT);
	dowsing_itemcontrol:SetQuantity(DOWSINGCOUNT);
	picks_itemcontrol:SetQuantity(PICKCOUNT);
	treasureSmall_itemcontrol:SetQuantity(SMALLCACHECOUNT);
	treasureMed_itemcontrol:SetQuantity(MEDIUMCACHECOUNT);
	treasureLarge_itemcontrol:SetQuantity(LARGECACHECOUNT);
	treasureshuge_itemcontrol:SetQuantity(HUGECACHECOUNT);

	RefreshStats();

end


function GetTokenCount()

	if TOKENINDEX > 0 then
		TOKENCOUNT = MYWALLET:GetItem(TOKENINDEX):GetQuantity();
		local QTYNEWTOKENS = TOKENCOUNT - TOKENOLDCOUNT;

		if QTYNEWTOKENS > 0 then -- looted rather than spent
			STATS[MYNAME].TOTALTOKENS = STATS[MYNAME].TOTALTOKENS + QTYNEWTOKENS;
		else	-- spent rather than looted
			STATS[MYNAME].TOTALSPENT = STATS[MYNAME].TOTALSPENT + math.abs(QTYNEWTOKENS);
		end

		tokens_image:SetBackground(MYWALLET:GetItem(TOKENINDEX):GetImage());
	else
		TOKENCOUNT = 0;
		tokens_image:SetBackground(_IMAGES.GREY_TOKENS);
	end

	TOKENOLDCOUNT = TOKENCOUNT;
	tokens_label_overlay:SetText(comma_value(TOKENCOUNT));

	RefreshStats();

end


function GetTokenIndex()

	TOKENINDEX = 0;

	for i=1, MYWALLET:GetSize() do
		if MYWALLET:GetItem(i):GetName() == _LANG.TOKENS[SETTINGS.LANGUAGE] then
			TOKENINDEX = i;
			TOKENOLDCOUNT = MYWALLET:GetItem(TOKENINDEX):GetQuantity();

			if STATS[MYNAME].TOTALTOKENS == 0 and TOKENOLDCOUNT > 0 then STATS[MYNAME].TOTALTOKENS = TOKENOLDCOUNT end;

			MYWALLET:GetItem(i).QuantityChanged = function (sender,args)
				GetTokenCount();
			end

			break;
		end
	end

	GetTokenCount();

end


function comma_value(amount)
  local formatted = amount
  while true do
    formatted, k = string.gsub(formatted, "^(-?%d+)(%d%d%d)", '%1,%2')
    if (k==0) then
      break
    end
  end
  return formatted
end
